echo "You need to edit this script first!"
exit
NOTE: Before using this script - edit variables in top section and remove this text so #!/bin/sh is at top

#!/bin/sh
# build script - IVA2K's debian packages for MythTV
# Ilya Ivanchenko, July 2007

UBUNTU_RELEASE="feisty"
UBUNTU_VERSION="7.04"
SVN_MAJOR_RELEASE="20"
SVN_MINOR_RELEASE="1"
SVN_TYPE="trunk"
#PKG_SUFFIX="-0.0ubuntu0`whoami`0"
PKG_SUFFIX="-0.0ubuntu0iva2k0"
BUILD_COMMENT='IVA2K Build from SVN, no debian/* changes.'

## Define hard-coded tasks (can use instead of command-line parameters)
#updatemyth=1
#unzipdeb=1
##updatedeb=1
dosource=1
dobuild=1
dorepository=1

DEBZIPFILE="./iva2k-mythtv-debscripts.tar.bz2"

## Define directories
MYTHSRC="./myth"
MYTHDEBSRC="./myth-debian"
MYTHUBUNTUSRC="./myth-ubuntu"
REPO="./repo"
PBUILDER_DIR="/var/cache/pbuilder/result"

###############################################################################################
#  The following does *not* need to be changed.  It is fully controlled via the environment   #
#  variables declared above.                                                                  #
###############################################################################################
MYROOTDIR=`pwd`
for a in $@ ; do
        if [ "$a" = "--updateall" ]; then
                updatemyth=1
#                updatedeb=1
        fi
        if [ "$a" = "--updatemyth" ]; then
                updatemyth=1
        fi
        if [ "$a" = "--unzipdeb" ]; then
                unzipdeb=1
        fi
#        if [ "$a" = "--updatedeb" ]; then
#                updatedeb=1
#        fi
        if [ "$a" = "--skipbuild" ]; then
                unset dobuild
        fi
        if [ "$a" = "--help" ]; then
                echo "  Usage: $0 [options]"
                echo "  Valid options are:"
                echo "    --updateall  : fetch all sources"
                echo "    --updatemyth : fetch mythtv sources"
                echo "    --unzipdeb   : unzip debian package wrappers"
#                echo "    --updatedeb  : fetch debian package wrappers"
                echo "    --skipbuild  : build source packages only, no binaries build"
                exit 1;
        fi
done
if [ ! -z "$updatemyth" ]; then
        dosource=1
fi
if [ ! -z "$updatedeb" ]; then
        copydebian=1
fi
if [ ! -z "$unzipdeb" ]; then
        copydebian=1
fi
if [ -z "$dobuild" ]; then
        unset dorepository
fi

sudo echo ""
#Populated variables used in build process
#unused: export DEBEMAIL="packages@mythbuntu.org"
#unused: export DEBFULLNAME="Mythbuntu Automated Package Builder"
if [ ! -z "$SVN_MINOR_RELEASE" ]; then
    SVN_RELEASE="0.$SVN_MAJOR_RELEASE.$SVN_MINOR_RELEASE"
else
    SVN_RELEASE="0.$SVN_MAJOR_RELEASE"
fi

if [ "$SVN_TYPE" = "fixes" ]; then
    MYTHTV_SVN_BRANCH="http://svn.mythtv.org/svn/branches/release-0-$SVN_MAJOR_RELEASE-fixes/mythtv"
    MYTHPLUGINS_SVN_BRANCH="http://svn.mythtv.org/svn/branches/release-0-$SVN_MAJOR_RELEASE-fixes/mythplugins"
    MYTHTHEMES_SVN_BRANCH="http://svn.mythtv.org/svn/branches/release-0-$SVN_MAJOR_RELEASE-fixes/myththemes"
elif [ "$SVN_TYPE" = "trunk" ]; then
    MYTHTV_SVN_BRANCH="http://svn.mythtv.org/svn/trunk/mythtv"
    MYTHPLUGINS_SVN_BRANCH="http://svn.mythtv.org/svn/trunk/mythplugins"
    MYTHTHEMES_SVN_BRANCH="http://svn.mythtv.org/svn/trunk/myththemes"
else
    echo "I don't know how to build $SVN_TYPE"
    exit 55
fi
#SVN_REVISION=`svn info $MYTHTV_SVN_BRANCH | grep Revision | cut -b 11-`
#SVN_REVISION_PLUGINS=`svn info $MYTHPLUGINS_SVN_BRANCH | grep Revision | cut -b 11-`
#SVN_REVISION_THEMES=`svn info $MYTHTHEMES_SVN_BRANCH | grep Revision | cut -b 11-`

echo "================================================================================"
echo "Running $0:"
echo "  UBUNTU_RELEASE/VERSION=$UBUNTU_RELEASE $UBUNTU_VERSION"
echo "  SVN_RELEASE=$SVN_RELEASE"
echo "  SVN_TYPE=$SVN_TYPE"
echo "  PKG_SUFFIX=$PKG_SUFFIX"
echo "  updatemyth=$updatemyth"
echo "  updatedeb=$updatedeb"
echo "  unzipdeb=$unzipdeb"
echo "  copydebian=$copydebian"
echo "  dosource=$dosource"
echo "  dobuild=$dobuild"
echo "  dorepository=$dorepository"

##==============================================================================
ensure_dir()
{
        if [ ! -d $1 ]; then
            echo "Unable to continue without $1 directory"
            exit 1
        fi
}

##==============================================================================
## $1 = SVN_BRANCH
## $2 = root dir
## $3 = project / subdir
svn_co_dir()
{
        mkdir -p $2
        if [ -d $2/$3 ]; then
                cd $2/$3
                svn update
                cd - >/dev/null
        else
                cd $2
                svn co $1
                cd - >/dev/null
        fi
        echo "Got $3"
}

##==============================================================================
## Update sources
if [ ! -z "$updatemyth" ]; then
        echo "===== UPDATING MYTHTV SOURCES =================================================="
        svn_co_dir $MYTHTV_SVN_BRANCH $MYTHSRC mythtv
        svn_co_dir $MYTHPLUGINS_SVN_BRANCH $MYTHSRC mythplugins
        svn_co_dir $MYTHTHEMES_SVN_BRANCH $MYTHSRC myththemes
fi
if [ ! -z "$unzipdeb" ]; then
        echo "===== UNZIPPING DEBIAN PACKAGE WRAPPERS ========================================"
	if [ ! -f $DEBZIPFILE ]; then
            echo "Unable to continue without $DEBZIPFILE file"
            exit 1
        fi
	echo $DEBZIPFILE
	tar -xjvf $DEBZIPFILE
	rm -R $MYTHDEBSRC
	mv -T iva2k-mythtv-debscripts $MYTHDEBSRC
	MYTHTVDEBSRC="$MYTHDEBSRC/mythtv/debian"
	MYTHPLUGINSDEBSRC="$MYTHDEBSRC/mythplugins/debian"
	MYTHTHEMESDEBSRC="$MYTHDEBSRC/myththemes/debian"
fi
if [ ! -z "$updatedeb" ]; then
        echo "===== UPDATING DEBIAN PACKAGE WRAPPERS ========================================="
        mkdir -p $MYTHDEBSRC
        if [ -d $MYTHDEBSRC/mythbuntu ]; then
                cd $MYTHDEBSRC/mythbuntu
                bzr update
                cd - >/dev/null
        else
                cd $MYTHDEBSRC
                bzr checkout http://bazaar.launchpad.net/~mythbuntu/mythbuntu/mythbuntu
#               bzr checkout http://bazaar.launchpad.net/~mythbuntu/mythbuntu/mythbuntu-meta-seeds
                cd - >/dev/null
        fi
        echo "Got mythbuntu"

        mkdir -p $MYTHUBUNTUSRC
        cd $MYTHUBUNTUSRC
        apt-get source mythtv-themes
        cd - >/dev/null
        echo "Got mythtv-themes"

	MYTHTVDEBSRC="$MYTHDEBSRC/mythbuntu/weekly_build/work/debian-mythtv"
	MYTHPLUGINSDEBSRC="$MYTHDEBSRC/mythbuntu/weekly_build/work/debian-mythplugins"
	MYTHTHEMESDEBSRC="$MYTHUBUNTUSRC/myththemes-0.20/debian"
fi

ensure_dir $MYTHSRC/mythtv
ensure_dir $MYTHSRC/mythplugins
ensure_dir $MYTHSRC/myththemes
if [ ! -z "$copydebian" ]; then
        echo "===== COPYING DEBIAN PACKAGE WRAPPERS =========================================="
        ensure_dir $MYTHTVDEBSRC
        ensure_dir $MYTHPLUGINSDEBSRC
        ensure_dir $MYTHTHEMESDEBSRC
        cp -RT $MYTHTVDEBSRC $MYTHSRC/mythtv/debian
        echo "$MYTHSRC/mythtv/debian"
        cp -RT $MYTHPLUGINSDEBSRC $MYTHSRC/mythplugins/debian
        echo "$MYTHSRC/mythplugins/debian"
        cp -RT $MYTHTHEMESDEBSRC $MYTHSRC/myththemes/debian
        echo "$MYTHSRC/myththemes/debian"
fi

PBUILDER_LIST=""
COPY_LIST=""
if [ ! -z "$dosource" ]; then
for b in mythtv mythplugins myththemes ; do
        echo "===== BUILDING SOURCE $b =============================================="
        cd $MYTHSRC/$b
        if [ -e debian/changelog.in ]; then
                cp debian/changelog.in debian/changelog
        fi
        SVN_REVISION=`svn info | grep Revision | cut -b 11-`
        dch -D $UBUNTU_RELEASE -v $SVN_RELEASE+$SVN_TYPE$SVN_REVISION$PKG_SUFFIX $BUILD_COMMENT
        cd - >/dev/null; cd $MYTHSRC
        mv $b $b-$SVN_RELEASE+$SVN_TYPE$SVN_REVISION
        tar -czf ${b}_$SVN_RELEASE+$SVN_TYPE$SVN_REVISION.orig.tar.gz \
            $b-$SVN_RELEASE+$SVN_TYPE$SVN_REVISION \
            --exclude .svn --exclude debian
        cd - >/dev/null; cd $MYTHSRC/$b-$SVN_RELEASE+$SVN_TYPE$SVN_REVISION
        debuild -i -S
        cd - >/dev/null; cd $MYTHSRC/
        mv $b-$SVN_RELEASE+$SVN_TYPE$SVN_REVISION $b
        cd - >/dev/null
        PBUILDER_LIST="$PBUILDER_LIST ${b}_$SVN_RELEASE+$SVN_TYPE$SVN_REVISION$PKG_SUFFIX.dsc"
        COPY_LIST="$COPY_LIST *$SVN_RELEASE+$SVN_TYPE$SVN_REVISION${PKG_SUFFIX}*"
done
fi

if [ ! -z "$dobuild" ]; then
#        echo "PBUILDER_LIST=$PBUILDER_LIST"
        cd $MYTHSRC
        for b in $PBUILDER_LIST ; do
                echo "===== BUILDING BINARIES ========================================================"
                echo "[$b]"
                sudo pbuilder build $b
        done
        cd - >/dev/null
fi

if [ ! -z $dorepository ]; then
        echo "===== COPYING BINARIES TO REPOSITORY ==========================================="
        echo $REPO
        mkdir -p $REPO
        cd $REPO
        for b in $COPY_LIST ; do
                cp -v $PBUILDER_DIR/$b .
        done
        cd - >/dev/null
fi

echo "DONE."
##END
